--[[
@title save ROM crash log to ROMLOG.LOG
@chdk_version 1.3
requires CHDK built with native function call support
@param   a remove old files 1=yes, 0=no
@default a 1
@range   a 0 1
@param   b append buildinfo
@default b 1
@range   b 0 1
@param   n Take a look
@default n 1
@range   n 0 1
--]]

LOG_NAME="A/ROMLOG.LOG"
ERR_NAME="A/RomLogErr.txt"

function printf(...)
    print(string.format(...))
end

function append_bi(n)
	n=io.open(n,"a")
	xx="-"
	bi=get_buildinfo()
	XX=string.upper(bi.platform)
	XX=XX..xx..bi.platsub
	XX=XX..xx..bi.version
	XX=XX..xx..bi.build_number
	XX=XX..xx..bi.build_revision
	XX=XX..xx..bi.platformid
	n:write(XX..'\n')
	n:write(' \n')
	n:close()
end


if (type(call_event_proc) ~= "function") then
    error("ERROR: your CHDK does not support native function calls")
end

if (call_event_proc("SystemEventInit") == -1) then
    -- Newest cams (DryOS rel 43 and later) only have System.Create()
    -- on older dryos cams SystemEventInit is an alias for System.Create()
    if (call_event_proc("System.Create") == -1) then
        error("ERROR: SystemEventInit and System.Create failed")
    end
end

if a ~= 0 then
    if (os.stat(LOG_NAME)) then
        printf("rm %s: %s",LOG_NAME,tostring(os.remove(LOG_NAME)));
    end
    if (os.stat(ERR_NAME)) then
        printf("rm %s: %s",ERR_NAME,tostring(os.remove(ERR_NAME)));
    end
end

-- first arg: filename, NULL for ROMLOG.TXT (dryos) or ROMLOG (vxworks)
-- second arg: if 0, shutdown camera after writing log
-- note, on vxworks the exception code, registers and stack trace are binary
r=call_event_proc("GetLogToFile",LOG_NAME,1) 

if r ~= 0 then
    printf("GetLogToFile return %d",r)
end

if (os.stat(ERR_NAME)) then
    if a ~= 0 then
        printf("FAIL check %s",ERR_NAME)
    else
        printf("%s exists",ERR_NAME)
    end
end

if (os.stat(LOG_NAME)) then
    printf("%s exists",LOG_NAME)
	if n==1 then 
		n=io.open(LOG_NAME,"r")
		if n then 
			lin=n:read(); print(lin);
			n:read();  n:read()
			lin=n:read(); print(lin);
		io.close(n)
		if b==1 then append_bi(LOG_NAME) end
		end
	wait_click(5000)
	end
else
    printf("%s not written",LOG_NAME)
sleep(2000)
end

